#! /usr/bin/perl -wT

use strict ;

do ("./lib.pl") || die( "could not include subroutine library ($!)" ) ;
our $DOCTYPE ;
our $WIKI_ROOT ;
our $EMBEDDED_WIKI_NAME_RE ;
our $WIKI_PAGE_FILENAME_RE ;
our @KEY_PAGES ;

($ENV{"REQUEST_METHOD"} eq "GET") || die( "script must be accessed by GET" ) ;
my $queryString = $ENV{"QUERY_STRING"} ;
my %query = &parse( $queryString ) ;
my $page = &cleanPage( $query{"page"} ) ;
my @backlinks = &backlinks( $page ) ;
my $pageUrl = &viewUrl( $page ) ;
print "Content-type: text/html\n" ;
print "\n" ;
print <<EOF ;
$DOCTYPE
<html>
<head>
<title>Backlinks to $page</title>
</head>
<body>
<h1>Backlinks to <a href="$pageUrl">$page</a></h1>
<hr>
<ul>
EOF

foreach my $backlink (@backlinks)
{
	my $backlinkUrl = &viewUrl( $backlink ) ;
	print "<li><a href=\"$backlinkUrl\">$backlink</a></li>\n" ;
}

print <<EOF ;
</ul>
<hr>
<p>
EOF
foreach my $keyPage (@KEY_PAGES)
{
	my $keyUrl = &viewUrl( $keyPage ) ;
	print "| <a href=\"$keyUrl\">$keyPage</a>\n" ;
}
print <<EOF ;
|
</p>
</body>
</html>
EOF

sub backlinks
{
	my $page = shift @_ ;
        opendir( DIR, $WIKI_ROOT ) ;
        my @files = readdir( DIR ) ;
	my @backlinkFiles = grep { &isBacklink( $_, $page ) } @files ;
	my @backlinks = map { substr( $_, 0, -6 ) } @backlinkFiles ;
	return @backlinks ;
}

sub isBacklink
{
	my $file = shift @_ ;
	my $page = shift @_ ;
	if ($file =~ /$WIKI_PAGE_FILENAME_RE/)
	{
		open( PAGE, ($WIKI_ROOT . $file) ) ;
		my $hit = 0 ;
		while (!$hit && (my $line = <PAGE>))
		{
			$hit = $line =~ $page ;
		}
		close( PAGE ) ;
		return $hit ;
	}
	else
	{
		return 0 ;
	}
}
