#! /usr/bin/perl -wT

use strict ;

do ("./lib.pl") || die( "could not include subroutine library ($!)" ) ;
our $DOCTYPE ;

# for running from command line
if (!defined( $ENV{"REQUEST_METHOD"} ))
{
        $ENV{"REQUEST_METHOD"} = "POST" ;
        $ENV{"QUERY_STRING"} = "page=FrontPage" ;
        $ENV{"CONTENT_TYPE"} = "application/x-www-form-urlencoded" ;
}

my $queryString = $ENV{"QUERY_STRING"} ;
my %query = parse( $queryString ) ;
my $page = &cleanPage( $query{"page"} ) ;
my $pageFile = &pageFile( $page ) ;
my $requestMethod = $ENV{"REQUEST_METHOD"} ;
if ($requestMethod eq "GET")
{
	&get() ;
}
else
{
	$requestMethod eq "POST" || die( "bad request method: $requestMethod" ) ;
	&post() ;
}

sub get
{
	print "Content-type: text/html\n" ;
	print "\n" ;
	my $action = editUrl( $page ) ;
	print <<EOF ;
$DOCTYPE
<html>
<head>
<title>Edit $page</title>
</head>
<body>
<h1>$page</h1>
<hr>
<form action="$action" method="POST">
<textarea name="text" rows="20" cols="80">
EOF
	if (&exists( $page ))
	{
		open( PAGE, "< " . $pageFile ) || die( "could not open page file: $pageFile ($!)" ) ;
		while (my $line = <PAGE>)
		{
			print $line ;
		}
		close( PAGE ) ;
	}
	print <<EOF ;
</textarea>
<br>
<input type="submit">
<input type="reset">
</form>
<p>Remember, kids: separate paragraphs with blank lines, start list items
with hyphens, make text _italic_ or *bold*, LinkToOtherPages, use URLs
freestyle, and <em>be excellent to each other</em>!</p>
</body>
</html>
EOF
}

sub post
{
	my $contentType = $ENV{'CONTENT_TYPE'} ;
	defined( $contentType ) || die( "undefined content type" ) ;
	($contentType =~ m#^application/x-www-form-urlencoded$#i) || die( "bad content type: $contentType " ) ;
	my $in ;
	my $contentLength = $ENV{'CONTENT_LENGTH'} ;
	if ($contentLength)
	{
		read( STDIN, $in, $contentLength ) ;
	}
	else
	{
		my $linesep = $/ ;
		$/ = undef ;
		$in = <STDIN> ;
		$/ = $linesep ;
	}
	my %form = parse( $in ) ;
	my $text = $form{"text"} ;
	defined( $text ) || die( "text not defined in form: $in" ) ;
	$text = &normaliseLines( $text ) ;
	open( PAGE, "> " . $pageFile )
		|| die( "could not open page file: $pageFile ($!)" ) ;
	print PAGE $text || die( "could not write to page file: $pageFile ($!)" ) ;
	close( PAGE ) ;
	print "Content-type: text/html\n" ;
	print "\n" ;
	my $viewUrl = viewUrl( $page ) ;
	my $editUrl = editUrl( $page ) ;
	print <<EOF ;
$DOCTYPE
<html>
<head>
<title>Edited $page</title>
</head>
<body>
<h1>$page</h1>
<p>You have edited <a href="$viewUrl">$page</a>; you should view it to
check that your changes are okay. Alternatively, you may <a
href="$editUrl">edit</a> it again if you like.</p>
</body>
</html>
EOF
}
